<?php
/**
* 2015 Skrill
*
* NOTICE OF LICENSE
*
* This source file is subject to the Academic Free License (AFL 3.0)
* that is bundled with this package in the file LICENSE.txt.
* It is also available through the world-wide-web at this URL:
* http://opensource.org/licenses/afl-3.0.php
* If you did not receive a copy of the license and are unable to
* obtain it through the world-wide-web, please send an email
* to license@prestashop.com so we can send you a copy immediately.
*
*  @author    Skrill <contact@skrill.com>
*  @copyright 2015 Skrill
*  @license   http://opensource.org/licenses/afl-3.0.php  Academic Free License (AFL 3.0)
*  International Registered Trademark & Property of Skrill
*/

class PlacetgroupPaymentReturnModuleFrontController extends ModuleFrontController
{
    public function initContent()
    {
        $status = Tools::getValue('status');
        if($status === 'error') {
            $this->display_column_left = false;
            $this->process();
            if (!isset($this->context->cart)) {
                $this->context->cart = new Cart();
            }
            Tools::redirect(
                $this->context->link->getPageLink('order', true, null, array('step' => '3'))
            );
        } else {
            $context = Context::getContext();
            $cart = $context->cart;
            $bankwire = Module::getInstanceByName('bankwire');

            if ($cart->id_customer == 0 OR $cart->id_address_delivery == 0 OR $cart->id_address_invoice == 0 OR !$bankwire->active)
                Tools::redirect('index.php?controller=order&step=1');
            $authorized = false;
            foreach (Module::getPaymentModules() as $module)
                if ($module['name'] == 'bankwire')
                {
                    $authorized = true;
                    break;
                }
            if (!$authorized)
                die($bankwire->l('This payment method is not available.', 'validation'));

            $customer = new Customer((int)$cart->id_customer);

            if (!Validate::isLoadedObject($customer))
                Tools::redirect('index.php?controller=order&step=1');

            $currency = $context->currency;
            $total = (float)($cart->getOrderTotal(true, Cart::BOTH));

            $bankwire->validateOrder($cart->id, Configuration::get('PS_OS_BANKWIRE'), $total, $bankwire->displayName, NULL, array(), (int)$currency->id, false, $customer->secure_key);

            $order = new Order($bankwire->currentOrder);
            Tools::redirect('index.php?controller=order-confirmation&id_cart='.$cart->id.'&id_module='.$bankwire->id.'&id_order='.$bankwire->currentOrder.'&key='.$customer->secure_key);
        }
    }
}
